// babylone.c
// bruno bouzy
// 22 decembre 2011

#include <stdio.h>

//////////////////////////////////////////////////////////
int main() {
  printf("Algorithme de Babylone.\n");
  printf("Calcul de la racine carree d'un nombre A avec une precision P.\n");

  float x, a, precision;
  printf("Nombre A ? "); scanf("%f", &a);
  printf("Precision P ? "); scanf("%f", &precision);
  printf("Valeur initiale ? "); scanf("%f", &x);
  
  int i=1;
  float erreur;
  do {
    float xsave = x;
    x = (x + a/x)/2;
    printf("x%d = %.10f\n", i, x);
    erreur = x - xsave; 
    if (erreur<0) erreur = -erreur;
    printf("erreur = %.10f\n", erreur);
    // printf("precision = %.10f\n", precision);
    i++;
  } while (erreur>precision);

  return 0;
}

