// losange.c
// Bruno Bouzy
// 24 novembre 2010

#include <stdio.h>

int main() {
  int n, ligne, i; 
  printf("n ? "); scanf("%d", &n);

  // solution 1 avec formats (comme en pascal)
  if (n>0) printf("%*c\n", n, '*');
  for (ligne=1; ligne<n; ligne++) printf("%*c%*c\n", n-ligne, '*', 2*ligne, '*');
  for (ligne=n-2; ligne>0; ligne--) printf("%*c%*c\n", n-ligne, '*', 2*ligne, '*');
  if (n>1) printf("%*c\n", n, '*');

  return (0);
}

/*
  // solution 2 avec formats (comme en pascal)
  if (n>0) printf("%*c\n", n, '*');
  for (ligne=1, i=1; n>1 && ligne>0; ligne+=i) {
    printf("%*c%*c\n", n-ligne, '*', 2*ligne, '*');
    if (ligne==n-1) i = -1;
  }
  if (n>1) printf("%*c\n", n, '*');
*/

/*
  // solution sans boucle imbriquee
  for (i=1; n>0 && i<=2*n*(2*n-1); i++) {
    ligne = i/(2*n);
    if (ligne>=n) ligne=2*n-2-ligne;
    if (i%(2*n)==0) printf("\n");
    else if (i%(2*n)==n-ligne) printf("*");
    else if (i%(2*n)==n+ligne) printf("*");
    else printf(" ");
  }
*/

/*
  // 1ere solution "normale" avec boucles imbriquees.
  if (n>0) {
    for (i=0; i<n; i++) printf(" ");
    printf("*\n");
  }
  for (ligne=1; ligne<n; ligne++) {
    for (i=0; i<n-ligne; i++) printf(" ");
    printf("*");
    for (i=0; i<2*ligne-1; i++) printf(" ");
    printf("*\n");
  }
  for (ligne=n-2; ligne>0; ligne--) {
    for (i=0; i<n-ligne; i++) printf(" ");
    printf("*");
    for (i=0; i<2*ligne-1; i++) printf(" ");
    printf("*\n");
  }
  if (n>1) {
    for (i=0; i<n; i++) printf(" ");
    printf("*\n");
  }
 */

